diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index d7e4749..e01a9ec 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -2556,911 +2267,321 @@ _cl5CheckCSNinCL(const ruv_enum_data *element, void *arg)
 
     data.flags = DB_DBT_MALLOC;
 
-    rc = file->db->get(file->db, NULL /*txn*/, &key, &data, 0);
+    rc = cldb->db->get(cldb->db, NULL /*txn*/, &key, &data, 0);
 
     slapi_ch_free(&(data.data));
     return rc;
 }
 
 static int32_t
-_cl5CheckMaxRUV(CL5DBFile *file, RUV *maxruv)
+_cl5CheckMaxRUV(cldb_Handle *cldb, RUV *maxruv)
 {
     int rc = 0;
 
-    rc = ruv_enumerate_elements(maxruv, _cl5CheckCSNinCL, (void *)file);
+    rc = ruv_enumerate_elements(maxruv, _cl5CheckCSNinCL, (void *)cldb);
 
     return rc;
 }
-/* upgrade from db33 to db41
- * 1. Run recovery on the database environment using the DB_ENV->open method
- * 2. Remove any Berkeley DB environment using the DB_ENV->remove method
- * 3. Remove any Berkeley DB transaction log files
- * 4. extention .db3 -> .db4
- */
-static int
-_cl5UpgradeMajor(char *fromVersion, char *toVersion)
+
+/* must be called under the state lock */
+static void
+_cl5Close(void)
 {
-    PRDir *dir = NULL;
-    PRDirEntry *entry = NULL;
-    DB *thisdb = NULL;
-    CL5OpenMode backup;
-    int rc = 0;
+ 
+    if (s_cl5Desc.dbState != CL5_STATE_CLOSED) /* Don't try to close twice */
+    {
+ 
+        /* cl5Close() set the state flag to CL5_STATE_CLOSING, which should
+           trigger all of the db housekeeping threads to exit, and which will
+           eventually cause no new update threads to start - so we wait here
+           for those other threads to finish before we proceed */
+        /* Stopping and waiting for threads to complet is now done for each
+         * replica in cldb_UnSetReplicaDB
+         */
 
-    backup = s_cl5Desc.dbOpenMode;
-    s_cl5Desc.dbOpenMode = CL5_OPEN_CLEAN_RECOVER;
-    /* CL5_OPEN_CLEAN_RECOVER does 1 and 2 */
-    rc = _cl5AppInit();
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5UpgradeMajor - Failed to open the db env\n");
-        s_cl5Desc.dbOpenMode = backup;
-        return rc;
+        replica_enumerate_replicas(cldb_UnSetReplicaDB, NULL);
+ 
+        /* There should now be no threads accessing any of the changelog databases -
+           it is safe to remove those databases */
+        _cl5DBClose();
+ 
     }
-    s_cl5Desc.dbOpenMode = backup;
+}
 
-    dir = PR_OpenDir(s_cl5Desc.dbDir);
-    if (dir == NULL) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5UpgradeMajor - Failed to open changelog dir %s; NSPR error - %d\n",
-                      s_cl5Desc.dbDir, PR_GetError());
-        goto out;
-    }
+static void
+_cl5DBClose(void)
+{
+    replica_enumerate_replicas(_cl5WriteReplicaRUV, NULL);
+}
 
-    while (NULL != (entry = PR_ReadDir(dir, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        if (NULL == entry->name) {
-            break;
-        }
-        if (_cl5FileEndsWith(entry->name, DB_EXTENSION_DB3) ||
-            _cl5FileEndsWith(entry->name, DB_EXTENSION_DB4)) {
-            char oName[MAXPATHLEN + 1];
-            char nName[MAXPATHLEN + 1];
-            char *p = NULL;
-            char c;
-            int baselen = 0;
-            PR_snprintf(oName, MAXPATHLEN, "%s/%s", s_cl5Desc.dbDir, entry->name);
-            p = strstr(oName, DB_EXTENSION_DB3);
-            if (NULL == p) {
-                p = strstr(oName, DB_EXTENSION_DB4);
-                if (NULL == p) {
-                    continue;
-                }
-            }
+static int
+_cl5TrimMain(void *param)
+{
+    time_t timePrev = slapi_current_utc_time();
+    time_t timeNow;
+    Replica *replica = (Replica *)param;
+    cldb_Handle *cldb = replica_get_file_info(replica);
 
-            /* db->rename closes DB; need to create every time */
-            rc = db_create(&thisdb, s_cl5Desc.dbEnv, 0);
-            if (0 != rc) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5UpgradeMajor - Failed to get db handle\n");
-                goto out;
-            }
+    slapi_counter_increment(cldb->clThreads);
 
-            baselen = p - oName;
-            c = *p;
-            *p = '\0';
-            PR_snprintf(nName, MAXPATHLEN + 1, "%s", oName);
-            PR_snprintf(nName + baselen, MAXPATHLEN + 1 - baselen, "%s", DB_EXTENSION);
-            *p = c;
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5UpgradeMajor - Renaming %s to %s\n", oName, nName);
-            rc = thisdb->rename(thisdb, (const char *)oName, NULL /* subdb */,
-                                (const char *)nName, 0);
-            if (rc != PR_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "_cl5UpgradeMajor - Failed to rename file (%s -> %s); "
-                              "db error - %d %s\n",
-                              oName, nName, rc, db_strerror(rc));
-                break;
-            }
+    while ((s_cl5Desc.dbState != CL5_STATE_CLOSING) &&
+            (cldb->flags & DB_FILE_ACTIVE)){
+        timeNow = slapi_current_utc_time();
+        if (timeNow - timePrev >= cldb->clConf.trimInterval) {
+            /* time to trim */
+            timePrev = timeNow;
+            _cl5TrimReplica(replica);
         }
+        if (NULL == cldb->clLock) {
+            /* most likely, emergency */
+            break;
+        }
+
+        PR_Lock(cldb->clLock);
+        PR_WaitCondVar(cldb->clCvar, PR_SecondsToInterval(cldb->clConf.trimInterval));
+        PR_Unlock(cldb->clLock);
     }
-    /* update the version file */
-    _cl5WriteDBVersion();
-    slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name_cl,
-                  "_cl5UpgradeMajor - Upgrading from %s to %s is successfully done (%s)\n",
-                  fromVersion, toVersion, s_cl5Desc.dbDir);
-out:
-    if (NULL != dir) {
-        PR_CloseDir(dir);
-    }
-    return rc;
+
+    slapi_counter_decrement(cldb->clThreads);
+
+    return 0;
 }
 
-/* upgrade from db41 -> db42 -> db43 -> db44 -> db45
- * 1. Run recovery on the database environment using the DB_ENV->open method
- * 2. Remove any Berkeley DB environment using the DB_ENV->remove method
- * 3. Remove any Berkeley DB transaction log files
+/*
+ * We remove an entry if it has been replayed to all consumers and the number
+ * of entries in the changelog is larger than maxEntries or age of the entry
+ * is larger than maxAge.  Also we can't purge entries which correspond to max
+ * csns in the supplier's ruv. Here is a example where we can get into trouble:
+ *
+ *   The server is setup with time based trimming and no consumer's
+ *   At some point all the entries are trimmed from the changelog.
+ *   At a later point a consumer is added and initialized online.
+ *   Then a change is made on the supplier.
+ *   To update the consumer, the supplier would attempt to locate the last
+ *   change sent to the consumer in the changelog and will fail because the
+ *   change was removed.
  */
-static int
-_cl5UpgradeMinor(char *fromVersion, char *toVersion)
+/*
+ * We are purging a changelog after a cleanAllRUV task.  Find the specific
+ * changelog for the backend that is being cleaned, and purge all the records
+ * with the cleaned rid.
+ */
+static void
+_cl5DoPurging(cleanruv_purge_data *purge_data)
 {
-    CL5OpenMode backup;
-    int rc = 0;
-
-    backup = s_cl5Desc.dbOpenMode;
-    s_cl5Desc.dbOpenMode = CL5_OPEN_CLEAN_RECOVER;
-    /* CL5_OPEN_CLEAN_RECOVER does 1 and 2 */
-    rc = _cl5AppInit();
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5UpgradeMinor - Failed to open the db env\n");
-        return rc;
-    }
-    s_cl5Desc.dbOpenMode = backup;
-
-    /* update the version file */
-    _cl5WriteDBVersion();
-    slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name_cl,
-                  "_cl5UpgradeMinor - Upgrading from %s to %s is successfully done (%s)\n",
-                  fromVersion, toVersion, s_cl5Desc.dbDir);
+    ReplicaId rid = purge_data->cleaned_rid;
+    const Slapi_DN *suffix_sdn = purge_data->suffix_sdn;
+    cldb_Handle *cldb = replica_get_file_info(purge_data->replica);
 
-    return rc;
+    PR_Lock (cldb->clLock);
+    _cl5PurgeRID (cldb, rid);
+    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
+                  "_cl5DoPurging - Purged rid (%d) from suffix (%s)\n",
+                  rid, slapi_sdn_get_dn(suffix_sdn));
+    PR_Unlock (cldb->clLock);
+    return;
 }
 
+/*
+ * If the rid is not set it is the very first iteration of the changelog.
+ * If the rid is set, we are doing another pass, and we have a key as our
+ * starting point.
+ */
 static int
-_cl5CheckDBVersion(void)
+_cl5PurgeGetFirstEntry(cldb_Handle *cldb, CL5Entry *entry, void **iterator, DB_TXN *txnid, int rid, DBT *key)
 {
-    char clVersion[VERSION_SIZE + 1];
-    char dbVersion[VERSION_SIZE + 1];
+    DBC *cursor = NULL;
+    DBT data = {0};
+    CL5Iterator *it;
     int rc;
 
-    if (!cl5Exist(s_cl5Desc.dbDir)) {
-        /* this is new changelog - write DB version and guardian file */
-        rc = _cl5WriteDBVersion();
-    } else {
-        char *versionp = NULL;
-        char *versionendp = NULL;
-        char *dotp = NULL;
-        int dbmajor = 0;
-        int dbminor = 0;
-
-        PR_snprintf(clVersion, VERSION_SIZE, "%s/%d.%d/%s",
-                    BDB_IMPL, DB_VERSION_MAJOR, DB_VERSION_MINOR, BDB_REPLPLUGIN);
-
-        rc = _cl5ReadDBVersion(s_cl5Desc.dbDir, dbVersion, sizeof(dbVersion));
+    /* create cursor */
+    rc = cldb->db->cursor(cldb->db, txnid, &cursor, 0);
+    if (rc != 0) {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                      "_cl5PurgeGetFirstEntry - Failed to create cursor; db error - %d %s\n", rc, db_strerror(rc));
+        rc = CL5_DB_ERROR;
+        goto done;
+    }
 
-        if (rc != CL5_SUCCESS) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5CheckDBVersion - Invalid dbversion\n");
-            rc = CL5_BAD_DBVERSION;
-            goto bailout;
-        }
-        versionendp = dbVersion + strlen(dbVersion);
-        /* get the version number */
-        /* old DBVERSION string: CL5_TYPE/REPL_PLUGIN_NAME/#.# */
-        if (PL_strncmp(dbVersion, CL5_TYPE, strlen(CL5_TYPE)) == 0) {
-            versionp = strrchr(dbVersion, '/');
-        }
-        /* new DBVERSION string: bdb/#.#/libreplication-plugin */
-        else if (PL_strncmp(dbVersion, BDB_IMPL, strlen(BDB_IMPL)) == 0) {
-            versionp = strchr(dbVersion, '/');
-        }
-        if (NULL == versionp || versionp == versionendp) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5CheckDBVersion - Invalid dbversion: %s\n", dbVersion);
-            rc = CL5_BAD_DBVERSION;
-            goto bailout;
-        }
-        dotp = strchr(++versionp, '.');
-        if (NULL != dotp) {
-            *dotp = '\0';
-            dbmajor = strtol(versionp, (char **)NULL, 10);
-            dbminor = strtol(dotp + 1, (char **)NULL, 10);
-            *dotp = '.';
-        } else {
-            dbmajor = strtol(versionp, (char **)NULL, 10);
+    key->flags = DB_DBT_MALLOC;
+    data.flags = DB_DBT_MALLOC;
+    while ((rc = cursor->c_get(cursor, key, &data, rid ? DB_SET : DB_NEXT)) == 0) {
+        /* skip service entries on the first pass (rid == 0)*/
+        if (!rid && cl5HelperEntry((char *)key->data, NULL)) {
+            slapi_ch_free(&key->data);
+            slapi_ch_free(&(data.data));
+            continue;
         }
 
-        if (dbmajor < DB_VERSION_MAJOR) {
-            /* upgrade */
-            rc = _cl5UpgradeMajor(dbVersion, clVersion);
-            if (rc != CL5_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5CheckDBVersion - Upgrade %s -> %s failed\n",
-                              dbVersion, clVersion);
-                rc = CL5_BAD_DBVERSION;
-            }
-        } else if (dbminor < DB_VERSION_MINOR) {
-            /* minor upgrade */
-            rc = _cl5UpgradeMinor(dbVersion, clVersion);
-            if (rc != CL5_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5CheckDBVersion - Upgrade %s -> %s failed\n",
-                              dbVersion, clVersion);
-                rc = CL5_BAD_DBVERSION;
-            }
+        /* format entry */
+        rc = cl5DBData2Entry(data.data, data.size, entry, cldb->clcrypt_handle);
+        slapi_ch_free(&(data.data));
+        if (rc != 0) {
+            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
+                          "_cl5PurgeGetFirstEntry - Failed to format entry: %d\n", rc);
+            goto done;
         }
-    }
-bailout:
-    return rc;
-}
 
-static int
-_cl5ReadDBVersion(const char *dir, char *clVersion, int buflen)
-{
-    int rc;
-    PRFileDesc *file;
-    char fName[MAXPATHLEN + 1];
-    char buff[BUFSIZ];
-    PRInt32 size;
-    char *tok;
-    char *iter = NULL;
+        it = (CL5Iterator *)slapi_ch_malloc(sizeof(CL5Iterator));
+        it->cursor = cursor;
+        /* TBD do we need to lock the file in the iterator ?? */
+        /* object_acquire (obj); */
+        it->it_cldb = cldb;
+        *(CL5Iterator **)iterator = it;
 
-    if (clVersion) {
-        clVersion[0] = '\0';
+        return CL5_SUCCESS;
     }
 
-    PR_snprintf(fName, MAXPATHLEN, "%s/%s", dir, VERSION_FILE);
-
-    file = PR_Open(fName, PR_RDONLY, 777);
-    if (file == NULL) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5ReadDBVersion - Failed to open DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
+    slapi_ch_free(&key->data);
+    slapi_ch_free(&(data.data));
 
-    size = slapi_read_buffer(file, buff, BUFSIZ);
-    if (size < 0) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5ReadDBVersion - Failed to read DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        PR_Close(file);
-        return CL5_SYSTEM_ERROR;
+    /* walked of the end of the file */
+    if (rc == DB_NOTFOUND) {
+        rc = CL5_NOTFOUND;
+        goto done;
     }
 
-    /* parse the data */
-    buff[size] = '\0';
-    tok = ldap_utf8strtok_r(buff, "\n", &iter);
-    if (tok) {
-        if (clVersion) {
-            PL_strncpyz(clVersion, tok, buflen);
-        }
-    }
+    /* db error occured while iterating */
+    slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                  "_cl5PurgeGetFirstEntry - Failed to get entry; db error - %d %s\n",
+                  rc, db_strerror(rc));
+    rc = CL5_DB_ERROR;
 
-    rc = PR_Close(file);
-    if (rc != PR_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5ReadDBVersion - Failed to close DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
+done:
+    /*
+     * We didn't success in assigning this cursor to the iterator,
+     * so we need to free the cursor here.
+     */
+    if (cursor)
+        cursor->c_close(cursor);
 
-    return CL5_SUCCESS;
+    return rc;
 }
 
+/*
+ * Get the next entry.  If we get a lock error we will restart the process
+ * starting at the current key.
+ */
 static int
-_cl5WriteDBVersion(void)
-{
-    int rc;
-    PRFileDesc *file;
-    char fName[MAXPATHLEN + 1];
-    char clVersion[VERSION_SIZE + 1];
-    PRInt32 len, size;
-
-    PR_snprintf(fName, MAXPATHLEN, "%s/%s", s_cl5Desc.dbDir, VERSION_FILE);
-
-    file = PR_Open(fName, PR_WRONLY | PR_CREATE_FILE | PR_TRUNCATE,
-                   s_cl5Desc.dbConfig.fileMode);
-    if (file == NULL) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5WriteDBVersion - Failed to open DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
-
-    /* write changelog version */
-    PR_snprintf(clVersion, VERSION_SIZE, "%s/%d.%d/%s\n",
-                BDB_IMPL, DB_VERSION_MAJOR, DB_VERSION_MINOR, BDB_REPLPLUGIN);
-
-    len = strlen(clVersion);
-    size = slapi_write_buffer(file, clVersion, len);
-    if (size != len) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5WriteDBVersion - Failed to write DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        PR_Close(file);
-        return CL5_SYSTEM_ERROR;
-    }
-
-    rc = PR_Close(file);
-    if (rc != PR_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5WriteDBVersion - Failed to close DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
-
-    return CL5_SUCCESS;
-}
-
-/* must be called under the state lock */
-static void
-_cl5Close(void)
-{
-    PRIntervalTime interval;
-
-    if (s_cl5Desc.dbState != CL5_STATE_CLOSED) /* Don't try to close twice */
-    {
-
-        /* cl5Close() set the state flag to CL5_STATE_CLOSING, which should
-           trigger all of the db housekeeping threads to exit, and which will
-           eventually cause no new update threads to start - so we wait here
-           for those other threads to finish before we proceed */
-        interval = PR_MillisecondsToInterval(100);
-        while (s_cl5Desc.threadCount > 0) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5Close -Waiting for threads to exit: %d thread(s) still active\n",
-                          s_cl5Desc.threadCount);
-            DS_Sleep(interval);
-        }
-
-        /* There should now be no threads accessing any of the changelog databases -
-           it is safe to remove those databases */
-        _cl5DBClose();
-
-        /* cleanup trimming */
-        _cl5TrimCleanup();
-
-        /* remove changelog if requested */
-        if (s_cl5Desc.dbRmOnClose) {
-
-            if (_cl5Delete(s_cl5Desc.dbDir, 1) != CL5_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "cl5Close - Failed to remove changelog\n");
-            }
-            s_cl5Desc.dbRmOnClose = PR_FALSE;
-        }
-
-        slapi_ch_free((void **)&s_cl5Desc.dbDir);
-        memset(&s_cl5Desc.dbConfig, 0, sizeof(s_cl5Desc.dbConfig));
-        s_cl5Desc.fatalError = PR_FALSE;
-        s_cl5Desc.threadCount = 0;
-        s_cl5Desc.dbOpenMode = CL5_OPEN_NONE;
-    }
-}
-
-static void
-_cl5DBClose(void)
-{
-    if (NULL != s_cl5Desc.dbFiles) {
-        Object *obj;
-        for (obj = objset_first_obj(s_cl5Desc.dbFiles); obj;
-             obj = objset_next_obj(s_cl5Desc.dbFiles, obj)) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5DBClose - Deleting DB object %p\n", obj);
-        }
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5DBClose - Closing databases in %s\n", s_cl5Desc.dbDir);
-        objset_delete(&s_cl5Desc.dbFiles);
-    }
-    if (NULL != s_cl5Desc.fileLock) {
-        PR_DestroyLock(s_cl5Desc.fileLock);
-        s_cl5Desc.fileLock = NULL;
-    }
-}
-
-/* see if the given file is a changelog db file */
-static int
-_cl5IsDbFile(const char *fname)
-{
-    if (!fname || !*fname) {
-        return 0;
-    }
-
-    if (!strcmp(fname, VERSION_FILE)) {
-        return 1;
-    }
-
-    if (_cl5FileEndsWith(fname, DB_EXTENSION)) {
-        return 1;
-    }
-
-    return 0; /* not a filename we recognize as being associated with the db */
-}
-
-/* state lock must be locked */
-static int
-_cl5Delete(const char *clDir, int rmDir)
+_cl5PurgeGetNextEntry(CL5Entry *entry, void *iterator, DBT *key)
 {
-    PRDir *dir;
-    char filename[MAXPATHLEN + 1];
-    PRDirEntry *entry = NULL;
+    CL5Iterator *it;
+    DBT data = {0};
     int rc;
-    int dirisempty = 1;
 
-    /* remove all files in the directory and the directory */
-    dir = PR_OpenDir(clDir);
-    if (dir == NULL) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Delete - Failed to open changelog dir; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
+    it = (CL5Iterator *)iterator;
 
-    while (NULL != (entry = PR_ReadDir(dir, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        if (NULL == entry->name) {
-            break;
-        }
-        if (!_cl5IsDbFile(entry->name)) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5Delete - Skipping file [%s/%s] because it is not a changelogdb file.\n",
-                          clDir, entry->name);
-            dirisempty = 0; /* skipped at least one file - dir not empty */
+    key->flags = DB_DBT_MALLOC;
+    data.flags = DB_DBT_MALLOC;
+    while ((rc = it->cursor->c_get(it->cursor, key, &data, DB_NEXT)) == 0) {
+        if (cl5HelperEntry((char *)key->data, NULL)) {
+            slapi_ch_free(&key->data);
+            slapi_ch_free(&(data.data));
             continue;
         }
-        PR_snprintf(filename, MAXPATHLEN, "%s/%s", clDir, entry->name);
-        /* _cl5Delete deletes the whole changelog directory with all the files
-         * underneath.  Thus, we can just remove them physically. */
-        if (0 == strcmp(entry->name, VERSION_FILE)) {
-            /* DBVERSION */
-            rc = PR_Delete(filename) != PR_SUCCESS;
-            if (PR_SUCCESS != rc) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5Delete - Failed to remove \"%s\"; NSPR error - %d\n",
-                              filename, PR_GetError());
-            }
-        } else {
-            /* DB files */
-            rc = s_cl5Desc.dbEnv->dbremove(s_cl5Desc.dbEnv, 0, filename, 0,
-                                           DEFAULT_DB_ENV_OP_FLAGS);
-            if (rc) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5Delete - Failed to remove \"%s\"; "
-                              "libdb error - %d (%s)\n",
-                              filename, rc, db_strerror(rc));
-            }
-        }
-    }
 
-    rc = PR_CloseDir(dir);
-    if (rc != PR_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Delete - Failed to close changelog dir (%s); NSPR error - %d\n",
-                      clDir, PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
-
-    if (rmDir && dirisempty) {
-        rc = PR_RmDir(clDir);
+        /* format entry */
+        rc = cl5DBData2Entry(data.data, data.size, entry, it->it_cldb->clcrypt_handle);
+        slapi_ch_free(&(data.data));
         if (rc != 0) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5Delete - Failed to remove changelog dir (%s); errno = %d\n",
-                          clDir, errno);
-            return CL5_SYSTEM_ERROR;
+            if (rc != CL5_DB_LOCK_ERROR) {
+                /* Not a lock error, free the key */
+                slapi_ch_free(&key->data);
+            }
+            slapi_log_err(rc == CL5_DB_LOCK_ERROR ? SLAPI_LOG_REPL : SLAPI_LOG_ERR,
+                          repl_plugin_name_cl,
+                          "_cl5PurgeGetNextEntry - Failed to format entry: %d\n",
+                          rc);
         }
-    } else if (rmDir && !dirisempty) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Delete - Changelog dir (%s) is not empty - cannot remove\n",
-                      clDir);
-    }
-
-    /* invalidate the clcache */
-    clcache_destroy();
-
-    return CL5_SUCCESS;
-}
-
-static void
-_cl5SetDefaultDBConfig(void)
-{
-    s_cl5Desc.dbConfig.fileMode = FILE_CREATE_MODE;
-}
-
-static void
-_cl5SetDBConfig(const CL5DBConfig *config)
-{
-    /* s_cl5Desc.dbConfig.pageSize is retrieved from backend */
-    /* Some other configuration parameters are hardcoded... */
-    s_cl5Desc.dbConfig.fileMode = FILE_CREATE_MODE;
-}
-
-/* Trimming helper functions */
-static int
-_cl5TrimInit(void)
-{
-    /* just create the lock while we are singlethreaded */
-    s_cl5Desc.dbTrim.lock = PR_NewLock();
 
-    if (s_cl5Desc.dbTrim.lock == NULL) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5InitTrimming - Failed to create lock; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    } else {
-        return CL5_SUCCESS;
+        return rc;
     }
-}
-
-static void
-_cl5TrimCleanup(void)
-{
-    if (s_cl5Desc.dbTrim.lock)
-        PR_DestroyLock(s_cl5Desc.dbTrim.lock);
-
-    memset(&s_cl5Desc.dbTrim, 0, sizeof(s_cl5Desc.dbTrim));
-}
-
-static int
-_cl5TrimMain(void *param __attribute__((unused)))
-{
-    time_t timePrev = slapi_current_utc_time();
-    time_t timeCompactPrev = slapi_current_utc_time();
-    time_t timeNow;
-
-    PR_AtomicIncrement(&s_cl5Desc.threadCount);
-
-    while (s_cl5Desc.dbState != CL5_STATE_CLOSING) {
-        timeNow = slapi_current_utc_time();
-        if (timeNow - timePrev >= s_cl5Desc.dbTrim.trimInterval) {
-            /* time to trim */
-            timePrev = timeNow;
-            _cl5DoTrimming();
-        }
-        if ((s_cl5Desc.dbTrim.compactInterval > 0) &&
-            (timeNow - timeCompactPrev >= s_cl5Desc.dbTrim.compactInterval)) {
-            /* time to trim */
-            timeCompactPrev = timeNow;
-            _cl5CompactDBs();
-        }
-        if (NULL == s_cl5Desc.clLock) {
-            /* most likely, emergency */
-            break;
-        }
+    slapi_ch_free(&(data.data));
 
-        PR_Lock(s_cl5Desc.clLock);
-        PR_WaitCondVar(s_cl5Desc.clCvar, PR_SecondsToInterval(s_cl5Desc.dbTrim.trimInterval));
-        PR_Unlock(s_cl5Desc.clLock);
+    /* walked of the end of the file or entry is out of range */
+    if (rc == 0 || rc == DB_NOTFOUND) {
+        slapi_ch_free(&key->data);
+        return CL5_NOTFOUND;
+    }
+    if (rc != CL5_DB_LOCK_ERROR) {
+        /* Not a lock error, free the key */
+        slapi_ch_free(&key->data);
     }
 
-    PR_AtomicDecrement(&s_cl5Desc.threadCount);
-    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5TrimMain - Exiting\n");
+    /* cursor operation failed */
+    slapi_log_err(rc == CL5_DB_LOCK_ERROR ? SLAPI_LOG_REPL : SLAPI_LOG_ERR,
+                  repl_plugin_name_cl,
+                  "_cl5PurgeGetNextEntry - Failed to get entry; db error - %d %s\n",
+                  rc, db_strerror(rc));
 
-    return 0;
+    return rc;
 }
 
+#define MAX_RETRIES 10
 /*
- * We remove an entry if it has been replayed to all consumers and the number
- * of entries in the changelog is larger than maxEntries or age of the entry
- * is larger than maxAge.  Also we can't purge entries which correspond to max
- * csns in the supplier's ruv. Here is a example where we can get into trouble:
+ *  _cl5PurgeRID(Object *obj,  ReplicaId cleaned_rid)
  *
- *   The server is setup with time based trimming and no consumer's
- *   At some point all the entries are trimmed from the changelog.
- *   At a later point a consumer is added and initialized online.
- *   Then a change is made on the supplier.
- *   To update the consumer, the supplier would attempt to locate the last
- *   change sent to the consumer in the changelog and will fail because the
- *   change was removed.
+ *  Clean the entire changelog of updates from the "cleaned rid" via CLEANALLRUV
+ *  Delete entries in batches so we don't consume too many db locks, and we don't
+ *  lockup the changelog during the entire purging process using one transaction.
+ *  We save the key from the last iteration so we don't have to start from the
+ *  beginning for each new iteration.
  */
 static void
-_cl5DoTrimming(void)
+_cl5PurgeRID(cldb_Handle *cldb, ReplicaId cleaned_rid)
 {
-    Object *file_obj;
-    long numToTrim;
+    slapi_operation_parameters op = {0};
+    ReplicaId csn_rid;
+    CL5Entry entry;
+    DB_TXN *txnid = NULL;
+    DBT key = {0};
+    void *iterator = NULL;
+    long totalTrimmed = 0;
+    long trimmed = 0;
+    char *starting_key = NULL;
+    int batch_count = 0;
+    int db_lock_retry_count = 0;
+    int first_pass = 1;
+    int finished = 0;
+    int rc = 0;
 
-    PR_Lock(s_cl5Desc.dbTrim.lock);
+    entry.op = &op;
 
     /*
-     * We are trimming all the changelogs.  We trim file by file which
-     * means that some files will be trimmed more often than other. We
-     * might have to fix that by, for example, randomizing the starting
-     * point.
+     * Keep processing the changelog until we are done, shutting down, or we
+     * maxed out on the db lock retries.
      */
-    file_obj = objset_first_obj(s_cl5Desc.dbFiles);
-    while (file_obj && _cl5CanTrim((time_t)0, &numToTrim)) {
-        _cl5TrimFile(file_obj, &numToTrim);
-        file_obj = objset_next_obj(s_cl5Desc.dbFiles, file_obj);
-    }
+    while (!finished && db_lock_retry_count < MAX_RETRIES && !slapi_is_shutting_down()) {
+        trimmed = 0;
 
-    if (file_obj)
-        object_release(file_obj);
+        /*
+         * Sleep a bit to allow others to use the changelog - we can't hog the
+         * changelog for the entire purge.
+         */
+        DS_Sleep(PR_MillisecondsToInterval(100));
 
-    PR_Unlock(s_cl5Desc.dbTrim.lock);
+        rc = TXN_BEGIN(s_cl5Desc.dbEnv, NULL, &txnid, 0);
+        if (rc != 0) {
+            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                          "_cl5PurgeRID - Failed to begin transaction; db error - %d %s.  "
+                          "Changelog was not purged of rid(%d)\n",
+                          rc, db_strerror(rc), cleaned_rid);
+            return;
+        }
 
-    return;
-}
-
-/*
- * We are purging a changelog after a cleanAllRUV task.  Find the specific
- * changelog for the backend that is being cleaned, and purge all the records
- * with the cleaned rid.
- */
-static void
-_cl5DoPurging(cleanruv_purge_data *purge_data)
-{
-    ReplicaId rid = purge_data->cleaned_rid;
-    const Slapi_DN *suffix_sdn = purge_data->suffix_sdn;
-    const char *replName = purge_data->replName;
-    char *replGen = purge_data->replGen;
-    char *fileName;
-    Object *file_obj;
-
-    PR_Lock(s_cl5Desc.dbTrim.lock);
-    fileName = _cl5MakeFileName(replName, replGen);
-    file_obj = objset_find(s_cl5Desc.dbFiles, _cl5CompareDBFile, fileName);
-    if (file_obj) {
-        /* We found our changelog, now purge it */
-        _cl5PurgeRID(file_obj, rid);
-        object_release(file_obj);
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5DoPurging - Purged rid (%d) from suffix (%s)\n",
-                      rid, slapi_sdn_get_dn(suffix_sdn));
-    } else {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5DoPurging - Purge rid (%d) failed to find changelog file (%s) for suffix (%s)\n",
-                      rid, fileName, slapi_sdn_get_dn(suffix_sdn));
-    }
-    PR_Unlock(s_cl5Desc.dbTrim.lock);
-
-    return;
-}
-
-/* clear free page files to reduce changelog */
-static void
-_cl5CompactDBs(void)
-{
-    int rc;
-    Object *fileObj = NULL;
-    CL5DBFile *dbFile = NULL;
-    DB *db = NULL;
-    DB_TXN *txnid = NULL;
-    DB_COMPACT c_data = {0};
-
-    PR_Lock(s_cl5Desc.dbTrim.lock);
-    rc = TXN_BEGIN(s_cl5Desc.dbEnv, NULL, &txnid, 0);
-    if (rc) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5CompactDBs - Failed to begin transaction; db error - %d %s\n",
-                      rc, db_strerror(rc));
-        goto bail;
-    }
-    for (fileObj = objset_first_obj(s_cl5Desc.dbFiles);
-         fileObj;
-         fileObj = objset_next_obj(s_cl5Desc.dbFiles, fileObj)) {
-        dbFile = (CL5DBFile *)object_get_data(fileObj);
-        if (!dbFile) {
-            continue;
-        }
-        db = dbFile->db;
-        rc = db->compact(db, txnid, NULL /*start*/, NULL /*stop*/,
-                         &c_data, DB_FREE_SPACE, NULL /*end*/);
-        if (rc) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5CompactDBs - Failed to compact %s; db error - %d %s\n",
-                          dbFile->replName, rc, db_strerror(rc));
-            goto bail;
-        }
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5CompactDBs - %s - %d pages freed\n",
-                      dbFile->replName, c_data.compact_pages_free);
-    }
-bail:
-    if (fileObj) {
-        object_release(fileObj);
-    }
-    if (rc) {
-        rc = TXN_ABORT(txnid);
-        if (rc) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5CompactDBs - Failed to abort transaction; db error - %d %s\n",
-                          rc, db_strerror(rc));
-        }
-    } else {
-        rc = TXN_COMMIT(txnid);
-        if (rc) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5CompactDBs - Failed to commit transaction; db error - %d %s\n",
-                          rc, db_strerror(rc));
-        }
-    }
-    PR_Unlock(s_cl5Desc.dbTrim.lock);
-
-    return;
-}
-
-/*
- * If the rid is not set it is the very first iteration of the changelog.
- * If the rid is set, we are doing another pass, and we have a key as our
- * starting point.
- */
-static int
-_cl5PurgeGetFirstEntry(Object *file_obj, CL5Entry *entry, void **iterator, DB_TXN *txnid, int rid, DBT *key)
-{
-    DBC *cursor = NULL;
-    DBT data = {0};
-    CL5Iterator *it;
-    CL5DBFile *file;
-    int rc;
-
-    file = (CL5DBFile *)object_get_data(file_obj);
-
-    /* create cursor */
-    rc = file->db->cursor(file->db, txnid, &cursor, 0);
-    if (rc != 0) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5PurgeGetFirstEntry - Failed to create cursor; db error - %d %s\n", rc, db_strerror(rc));
-        rc = CL5_DB_ERROR;
-        goto done;
-    }
-
-    key->flags = DB_DBT_MALLOC;
-    data.flags = DB_DBT_MALLOC;
-    while ((rc = cursor->c_get(cursor, key, &data, rid ? DB_SET : DB_NEXT)) == 0) {
-        /* skip service entries on the first pass (rid == 0)*/
-        if (!rid && cl5HelperEntry((char *)key->data, NULL)) {
-            slapi_ch_free(&key->data);
-            slapi_ch_free(&(data.data));
-            continue;
-        }
-
-        /* format entry */
-        rc = cl5DBData2Entry(data.data, data.size, entry);
-        slapi_ch_free(&(data.data));
-        if (rc != 0) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5PurgeGetFirstEntry - Failed to format entry: %d\n", rc);
-            goto done;
-        }
-
-        it = (CL5Iterator *)slapi_ch_malloc(sizeof(CL5Iterator));
-        it->cursor = cursor;
-        object_acquire(file_obj);
-        it->file = file_obj;
-        *(CL5Iterator **)iterator = it;
-
-        return CL5_SUCCESS;
-    }
-
-    slapi_ch_free(&key->data);
-    slapi_ch_free(&(data.data));
-
-    /* walked of the end of the file */
-    if (rc == DB_NOTFOUND) {
-        rc = CL5_NOTFOUND;
-        goto done;
-    }
-
-    /* db error occured while iterating */
-    slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                  "_cl5PurgeGetFirstEntry - Failed to get entry; db error - %d %s\n",
-                  rc, db_strerror(rc));
-    rc = CL5_DB_ERROR;
-
-done:
-    /*
-     * We didn't success in assigning this cursor to the iterator,
-     * so we need to free the cursor here.
-     */
-    if (cursor)
-        cursor->c_close(cursor);
-
-    return rc;
-}
-
-/*
- * Get the next entry.  If we get a lock error we will restart the process
- * starting at the current key.
- */
-static int
-_cl5PurgeGetNextEntry(CL5Entry *entry, void *iterator, DBT *key)
-{
-    CL5Iterator *it;
-    DBT data = {0};
-    int rc;
-
-    it = (CL5Iterator *)iterator;
-
-    key->flags = DB_DBT_MALLOC;
-    data.flags = DB_DBT_MALLOC;
-    while ((rc = it->cursor->c_get(it->cursor, key, &data, DB_NEXT)) == 0) {
-        if (cl5HelperEntry((char *)key->data, NULL)) {
-            slapi_ch_free(&key->data);
-            slapi_ch_free(&(data.data));
-            continue;
-        }
-
-        /* format entry */
-        rc = cl5DBData2Entry(data.data, data.size, entry);
-        slapi_ch_free(&(data.data));
-        if (rc != 0) {
-            if (rc != CL5_DB_LOCK_ERROR) {
-                /* Not a lock error, free the key */
-                slapi_ch_free(&key->data);
-            }
-            slapi_log_err(rc == CL5_DB_LOCK_ERROR ? SLAPI_LOG_REPL : SLAPI_LOG_ERR,
-                          repl_plugin_name_cl,
-                          "_cl5PurgeGetNextEntry - Failed to format entry: %d\n",
-                          rc);
-        }
-
-        return rc;
-    }
-    slapi_ch_free(&(data.data));
-
-    /* walked of the end of the file or entry is out of range */
-    if (rc == 0 || rc == DB_NOTFOUND) {
-        slapi_ch_free(&key->data);
-        return CL5_NOTFOUND;
-    }
-    if (rc != CL5_DB_LOCK_ERROR) {
-        /* Not a lock error, free the key */
-        slapi_ch_free(&key->data);
-    }
-
-    /* cursor operation failed */
-    slapi_log_err(rc == CL5_DB_LOCK_ERROR ? SLAPI_LOG_REPL : SLAPI_LOG_ERR,
-                  repl_plugin_name_cl,
-                  "_cl5PurgeGetNextEntry - Failed to get entry; db error - %d %s\n",
-                  rc, db_strerror(rc));
-
-    return rc;
-}
-
-#define MAX_RETRIES 10
-/*
- *  _cl5PurgeRID(Object *obj,  ReplicaId cleaned_rid)
- *
- *  Clean the entire changelog of updates from the "cleaned rid" via CLEANALLRUV
- *  Delete entries in batches so we don't consume too many db locks, and we don't
- *  lockup the changelog during the entire purging process using one transaction.
- *  We save the key from the last iteration so we don't have to start from the
- *  beginning for each new iteration.
- */
-static void
-_cl5PurgeRID(Object *file_obj, ReplicaId cleaned_rid)
-{
-    slapi_operation_parameters op = {0};
-    ReplicaId csn_rid;
-    CL5Entry entry;
-    DB_TXN *txnid = NULL;
-    DBT key = {0};
-    void *iterator = NULL;
-    long totalTrimmed = 0;
-    long trimmed = 0;
-    char *starting_key = NULL;
-    int batch_count = 0;
-    int db_lock_retry_count = 0;
-    int first_pass = 1;
-    int finished = 0;
-    int rc = 0;
-
-    PR_ASSERT(file_obj);
-    entry.op = &op;
-
-    /*
-     * Keep processing the changelog until we are done, shutting down, or we
-     * maxed out on the db lock retries.
-     */
-    while (!finished && db_lock_retry_count < MAX_RETRIES && !slapi_is_shutting_down()) {
-        trimmed = 0;
-
-        /*
-         * Sleep a bit to allow others to use the changelog - we can't hog the
-         * changelog for the entire purge.
-         */
-        DS_Sleep(PR_MillisecondsToInterval(100));
-
-        rc = TXN_BEGIN(s_cl5Desc.dbEnv, NULL, &txnid, 0);
-        if (rc != 0) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5PurgeRID - Failed to begin transaction; db error - %d %s.  "
-                          "Changelog was not purged of rid(%d)\n",
-                          rc, db_strerror(rc), cleaned_rid);
-            return;
-        }
-
-        /*
-         * Check every changelog entry for the cleaned rid
-         */
-        rc = _cl5PurgeGetFirstEntry(file_obj, &entry, &iterator, txnid, first_pass ? 0 : cleaned_rid, &key);
-        first_pass = 0;
-        while (rc == CL5_SUCCESS && !slapi_is_shutting_down()) {
-            /*
-             * Store the new starting key - we need this starting key in case
-             * we run out of locks and have to start the transaction over.
-             */
-            slapi_ch_free_string(&starting_key);
-            starting_key = slapi_ch_strdup((char *)key.data);
+        /*
+         * Check every changelog entry for the cleaned rid
+         */
+        rc = _cl5PurgeGetFirstEntry(cldb, &entry, &iterator, txnid, first_pass?0:cleaned_rid, &key);
+        first_pass = 0;
+        while (rc == CL5_SUCCESS && !slapi_is_shutting_down()) {
+            /*
+             * Store the new starting key - we need this starting key in case
+             * we run out of locks and have to start the transaction over.
+             */
+            slapi_ch_free_string(&starting_key);
+            starting_key = slapi_ch_strdup((char *)key.data);
 
             if (trimmed == 10000 || (batch_count && trimmed == batch_count)) {
                 /*
